--- main/say.c	2007-09-27 22:46:37.000000000 +0200
+++ main/say.c	2007-09-28 10:31:59.000000000 +0200
@@ -1491,10 +1491,10 @@
 		} else if (playh) {
 			snprintf(fn, sizeof(fn), "digits/hundred");
 			playh = 0;
-		} else if (num < 20) {
+		} else if (num < 20) {	/* 0 to 19 */
 			snprintf(fn, sizeof(fn), "digits/%d", num);
 			num = 0;
-		} else if (num < 100) {
+		} else if (num < 100) {	/* 20 to 99 */
 			units = num % 10;
 			if (units > 0) {
 				res = ast_say_number_full_nl(chan, units, ints, language, audiofd, ctrlfd);
@@ -1506,21 +1506,34 @@
 				snprintf(fn, sizeof(fn), "digits/%d", num - units);
 				num = 0;
 			}
+		} else if (num < 200) {	/* 100 to 199 */
+			strcpy(fn,"");
+			playh++;
+			num -= ((num / 100) * 100);
+		} else if (num < 1000) {	/* 200 to 999 */
+			snprintf(fn, sizeof(fn), "digits/%d", (num/100));
+			playh++;
+			num -= ((num / 100) * 100);
 		} else {
-			if (num < 1000) {
-				snprintf(fn, sizeof(fn), "digits/%d", (num/100));
-				playh++;
-				num -= ((num / 100) * 100);
+			if (num < 1100) 	{  /* 1,000 to 1,099 */
+				num = num % 1000;
+				snprintf(fn, sizeof(fn), "digits/thousand");
+			} else if (num < 10000)	{  /* 1,100 to 9,9999 */
+				res = ast_say_number_full_nl(chan, num / 100, ints, language, audiofd, ctrlfd);
+				if (res)
+					return res;
+				num = num % 100;
+				snprintf(fn, sizeof(fn), "digits/hundred");
 			} else {
-				if (num < 1000000) { /* 1,000,000 */
-					res = ast_say_number_full_en(chan, num / 1000, ints, language, audiofd, ctrlfd);
+				if (num < 1000000) { /* 10,000 to 1,000,000 */
+					res = ast_say_number_full_nl(chan, num / 1000, ints, language, audiofd, ctrlfd);
 					if (res)
 						return res;
 					num = num % 1000;
 					snprintf(fn, sizeof(fn), "digits/thousand");
 				} else {
 					if (num < 1000000000) { /* 1,000,000,000 */
-						res = ast_say_number_full_en(chan, num / 1000000, ints, language, audiofd, ctrlfd);
+						res = ast_say_number_full_nl(chan, num / 1000000, ints, language, audiofd, ctrlfd);
 						if (res)
 							return res;
 						num = num % 1000000;
